=== debian/changelog ===
gitaly (13.4.6+dfsg1-2) unstable; urgency=medium

  * Reupload to unstable
  * Bump Standards-Version to 4.5.1 (no changes needed)

 -- Pirate Praveen <praveen@debian.org>  Tue, 01 Dec 2020 20:22:20 +0530

gitaly (13.4.6+dfsg1-1) experimental; urgency=medium

  [ Pirate Praveen ]
  * New upstream version 13.4.6+dfsg
  * Refresh patches
  * Add new build dependency on golang-honnef-go-tools-dev
  * Update build dependencies
  * New upstream version 13.4.6+dfsg1 (drop embedded copy of gitaly client)

  [ Sruthi Chandran ]
  * Update minimum version for deps and builddeps

 -- Sruthi Chandran <srud@debian.org>  Fri, 27 Nov 2020 02:06:49 +0530
