## gitaly 15.4.2+dfsg

=== debian/changelog ===
gitaly (15.4.2+dfsg-1) experimental; urgency=medium

  * New upstream version 15.4.2+dfsg
  * Refresh patches
  * Update dependencies

 -- Pirate Praveen <praveen@debian.org>  Sun, 09 Oct 2022 23:54:13 +0530

gitaly (15.3.1+dfsg-2) experimental; urgency=medium

  * Update minimum version of gitlab-shell to 14.10
  * Update minimum version of activesupport to 6.1.6.1
  * Update gitlab-shell build dependency also to 14.10
  * Update minimum version of golang-github-git-lfs-git-lfs-dev to 3.0~
  * Add golang-gitlab-gitlab-org-gitlab-shell-v14-dev as dependency
  * Use golang git2go v34 to match libgit2 1.5

 -- Pirate Praveen <praveen@debian.org>  Mon, 03 Oct 2022 11:40:09 +0530

gitaly (15.3.1+dfsg-1) experimental; urgency=medium

  * New upstream version 15.3.1+dfsg
  * Refresh patches
  * Remove -v15 suffix from gitaly-git2go executable
  * Update minimum version of ruby-google-protobuf to 3.21

 -- Pirate Praveen <praveen@debian.org>  Sun, 28 Aug 2022 21:04:36 +0530

gitaly (15.2.2+dfsg2-2) experimental; urgency=medium

  * Update minimum version of gitlab-shell
  * Update minimum version of yamux in runtime dependency as well

 -- Pirate Praveen <praveen@debian.org>  Fri, 19 Aug 2022 23:10:13 +0530

gitaly (15.2.2+dfsg2-1) experimental; urgency=medium

  [ Nilesh Patra ]
  * Upstream came up with some sort of 'strange axe to grind' to install a
    few binaries mandatorily. It might be simply better to remove the
    stupid go:embed line since we build all binaries anyway, but let's keep
    it for the sake of less patching but it makes sense to get rid of it in
    long run. The way upstream organizes all of it is crazy -- they install
    things with bundler, make a custom build file and build the go libs as
    well with it. They do a horrible, horrible job there.

 -- Pirate Praveen <praveen@debian.org>  Thu, 18 Aug 2022 17:43:54 +0530

gitaly (15.2.2+dfsg1-1) experimental; urgency=medium

  * New upstream version 15.2.2+dfsg (drop vendored modules)
  * Refresh patches
  * Update dependencies

  [ Nilesh Patra ]
  * d/rules: Build more executables (fixes build failure)

 -- Pirate Praveen <praveen@debian.org>  Sun, 14 Aug 2022 22:23:46 +0530

gitaly (15.1.4+dfsg-1) experimental; urgency=medium

  * Update golang-gitlab-gitlab-org-labkit-dev (>= 1.16~)
  * Update golang-github-hashicorp-yamux-dev (>= 0.0+git20210316.a95892c~)
  * Vendor gitlab-shell version matching go.mod
  * New upstream version 15.1.4+dfsg
  * Update import path to v15

 -- Pirate Praveen <praveen@debian.org>  Sat, 30 Jul 2022 12:59:09 +0200

gitaly (15.0.4+dfsg-1) experimental; urgency=medium

  * New upstream version 15.0.4+dfsg
  * Update dependencies
  * Add golang-github-golang-jwt-jwt-dev as build dependency

 -- Pirate Praveen <praveen@debian.org>  Sun, 17 Jul 2022 11:33:33 +0200

gitaly (14.10.4+dfsg-1) experimental; urgency=medium

  * New upstream version 14.10.4+dfsg
  * Refresh patches
  * Add dependency on ruby-gitlab-markup
  * Update path for gitaly-git2go source directory
  * Update minimum version of ruby-activesupport
  * Update minimum version of gitlab-shell

 -- Pirate Praveen <praveen@debian.org>  Tue, 28 Jun 2022 01:35:25 +0530

gitaly (14.9.4+dfsg-2) experimental; urgency=medium

  * Update path for ruby-github-linguist languages.json in config.toml

 -- Pirate Praveen <praveen@debian.org>  Mon, 09 May 2022 00:34:29 +0530

gitaly (14.9.4+dfsg-1) experimental; urgency=medium

  * New upstream version 14.9.4+dfsg
  * Disable golang tests (hanging)
  * Update minimum version of gitlab-shell

 -- Pirate Praveen <praveen@debian.org>  Sun, 08 May 2022 22:22:42 +0530

gitaly (14.8.5+dfsg-1) experimental; urgency=medium

  * New upstream version 14.8.5+dfsg
  * Refresh patches
  * Update dependencies

 -- Pirate Praveen <praveen@debian.org>  Tue, 05 Apr 2022 16:31:28 +0530

gitaly (14.7.7+dfsg-2) experimental; urgency=medium

  * Update minimum version of gitlab-shell

 -- Pirate Praveen <praveen@debian.org>  Sat, 02 Apr 2022 13:08:44 +0530

gitaly (14.7.7+dfsg-1) experimental; urgency=medium

  * New upstream version 14.7.7+dfsg
  * Add back ruby-grpc dependency to ruby-gitaly

 -- Pirate Praveen <praveen@debian.org>  Fri, 01 Apr 2022 19:40:26 +0530

gitaly (14.7.4+dfsg-1) experimental; urgency=medium

  * New upstream version 14.7.4+dfsg
  * Refresh patches
  * Update dependencies

 -- Pirate Praveen <praveen@debian.org>  Mon, 28 Mar 2022 22:20:15 +0530

gitaly (14.6.3+dfsg-2) experimental; urgency=medium

  * Update minimum version of ruby-gollum-lib (for ruby-sanitize 6.0 compat)

 -- Pirate Praveen <praveen@debian.org>  Mon, 28 Feb 2022 00:27:15 +0530

gitaly (14.6.3+dfsg-1) experimental; urgency=medium

  * New upstream version 14.6.3+dfsg
  * Refresh patches
  * Add dependency on ruby-gitlab-license-finder

 -- Pirate Praveen <praveen@debian.org>  Sat, 22 Jan 2022 13:22:47 +0530

gitaly (14.5.2+dfsg-3) experimental; urgency=medium

  * Team Upload.
  * d/rules: Specify builddirectory for install
    + Populates golang-gitlab-gitlab-org-gitaly-dev with
      relevant files which was otherwise empty.

 -- Nilesh Patra <nilesh@debian.org>  Wed, 12 Jan 2022 17:01:33 +0000

gitaly (14.5.2+dfsg-2) experimental; urgency=medium

  * Update minimum version of ruby-rugged to 1.2
  * Update minimum version of gitlab-shell to 13.22.1

 -- Pirate Praveen <praveen@debian.org>  Fri, 17 Dec 2021 12:55:22 +0530

gitaly (14.5.2+dfsg-1) experimental; urgency=medium

  * New upstream version 14.5.2+dfsg
  * Refresh patches
  * Update libgit2/git2go dependency

 -- Pirate Praveen <praveen@debian.org>  Sat, 11 Dec 2021 22:01:12 +0530

gitaly (14.4.4+dfsg-1) experimental; urgency=medium

  [ Sahil Dhiman ]
  * Update control to update min version of ruby-activesupport

  [ Pirate Praveen ]
  * New upstream version 14.4.4+dfsg

 -- Pirate Praveen <praveen@debian.org>  Tue, 07 Dec 2021 21:52:48 +0530

gitaly (14.4.2+dfsg-2) experimental; urgency=medium

  * Update minimum version of golang-any to 2:1.17

