=== debian/control ===
Source: gitaly
Section: net
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Pirate Praveen <praveen@debian.org>,
 Sruthi Chandran <srud@debian.org>
Build-Depends: debhelper (>= 11~),
 dh-golang (>= 1.43~),
# See #1016217 (gccgo and x/net don't work well together right now)
# golang-any (>= 2:1.17~),
 golang-go (>= 2:1.17~),
 golang-github-beevik-ntp-dev,
 golang-github-beorn7-perks-dev,
 golang-github-burntsushi-toml-dev,
 golang-github-client9-reopen-dev,
 golang-github-cloudflare-tableflip-dev (>= 1.2~),
 golang-github-containerd-cgroups-dev,
 golang-github-davecgh-go-spew-dev,
 golang-github-dchest-safefile-dev,
 golang-github-getsentry-sentry-go-dev,
 golang-github-golang-jwt-jwt-dev,
 golang-github-git-lfs-git-lfs-dev (>= 3.0~),
 golang-github-google-uuid-dev,
 golang-github-go-enry-go-license-detector-dev,
 golang-github-grpc-ecosystem-go-grpc-middleware-dev (>= 1.2.3~),
 golang-github-grpc-ecosystem-go-grpc-prometheus-dev (>= 1.2~),
 golang-github-hashicorp-golang-lru-dev,
 golang-github-hashicorp-yamux-dev (>= 0.0+git20210316.a95892c~),
 golang-github-jackc-pgconn-dev,
 golang-github-jackc-pgx-v4-dev,
 golang-github-kelseyhightower-envconfig-dev,
 golang-github-lib-pq-dev (>= 1.3~),
 golang-github-opencontainers-specs-dev,
 golang-github-oklog-ulid-dev (>= 2.0~),
 golang-github-pelletier-go-toml.v2-dev,
 golang-github-pmezard-go-difflib-dev,
 golang-github-prometheus-client-golang-dev,
 golang-github-prometheus-client-model-dev,
 golang-github-prometheus-common-dev,
 golang-github-rubenv-sql-migrate-dev,
 golang-github-sebest-xff-dev,
 golang-github-sirupsen-logrus-dev (>= 1.0~),
 golang-github-stretchr-testify-dev (>= 1.4~),
 golang-gitlab-gitlab-org-gitlab-shell-v14-dev,
 golang-gitlab-gitlab-org-labkit-dev (>= 1.16~),
 golang-gocloud-dev,
 golang-golang-x-crypto-dev,
 golang-golang-x-net-dev,
 golang-golang-x-sync-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-text-dev,
 golang-golang-x-tools,
 golang-google-grpc-dev (>= 1.38.0-3~),
 golang-google-protobuf-dev,
 golang-gopkg-gorp.v1-dev,
 golang-github-libgit2-git2go-v34-dev,
 golang-gopkg-yaml.v2-dev,
 golang-goprotobuf-dev (>= 1.5~),
 golang-honnef-go-tools-dev,
 golang-procfs-dev,
 golang-protobuf-extensions-dev,
 golang-uber-goleak-dev,
 protobuf-compiler,
# Tests:
#  ,git
#  ,procps
 gem2deb,
 ruby-bundler,
 ruby-rugged (>= 1.2~),
 ruby-github-linguist (>= 7.20~),
 ruby-gitlab-markup (>= 1.7.1~),
 ruby-github-markup (>= 1.7.0~),
 ruby-gitlab-license-finder,
 ruby-activesupport (>= 2:6.1.6.1~),
 ruby-gollum-lib (>= 4.2.7.10~gitlab.2~),
 ruby-gollum-rugged-adapter (>= 0.4.4.4~),
 ruby-grpc (>= 1.42~),
 ruby-grpc-tools (>= 1.42~),
 ruby-sentry-raven (>= 3.0~),
 ruby-faraday (>= 0.12~),
 ruby-rbtrace,
 ruby-gitlab-labkit (>= 0.24~),
 ruby-licensee (>= 9.15~),
 ruby-google-protobuf (>= 3.21~)
Standards-Version: 4.6.1
Homepage: https://gitlab.com/gitlab-org/gitaly
Vcs-Git: https://salsa.debian.org/go-team/packages/gitaly.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/gitaly
XS-Ruby-Versions: all
XS-Go-Import-Path: gitlab.com/gitlab-org/gitaly/v15

Package: gitaly
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends}, ${misc:Depends},
     gitlab-common (=${source:Version}),
     ruby | ruby-interpreter,
     ruby-bundler,
     ruby-rugged (>= 1.2~),
     ruby-github-linguist (>= 7.20~),
     ruby-gitlab-markup (>= 1.7.1~),
     ruby-github-markup (>= 1.7.0~),
     ruby-gitlab-license-finder,
     ruby-activesupport (>= 2:6.1.6.1~),
     ruby-gollum-lib (>= 4.2.7.10~gitlab.2~),
     ruby-gollum-rugged-adapter (>= 0.4.4.4~),
     ruby-grpc (>= 1.42~),
     ruby-google-protobuf (>= 3.21~),
     ruby-sentry-raven (>= 3.0~),
     ruby-faraday (>= 0.12~),
     ruby-rbtrace,
     ruby-gitlab-labkit (>= 0.24~),
     ruby-licensee (>= 9.15~),
# sysv deps:
     pipexec,
     procps
Conflicts: libruby2.5
Description: Git RPC service for handling all the git calls made by GitLab
 Gitaly makes the git data storage tier of large GitLab instances fast.
 .
 This is achieved by moving git operations as close to the data as possible and
 Optimizing git services using caching.
 .
 Gitaly is a core service of gitlab.

Package: ruby-gitaly
Section: ruby
Architecture: all
XB-Ruby-Versions: ${ruby:Versions}
Depends: ruby | ruby-interpreter,
         ruby-grpc (>= 1.0~),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Auto-generated gRPC client for gitaly
 Auto-generated gRPC ruby client for gitaly.
 .
 Gitaly is part of GitLab. It is a server application that uses its own gRPC
 protocol to communicate with its clients.

Package: gitlab-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends},
 ruby | ruby-interpreter,
 adduser (>= 3.34~),
 git (>= 1:2.33~),
 ucf,
 gitlab-shell (>= 14.10~)
Description: git powered software platform to collaborate on code (common)
 gitlab provides web based interface to host source code and track issues.
 It allows anyone for fork a repository and send merge requests. Code review
 is possible using merge request workflow. Using groups and roles project
 access can be controlled.
 .
 This package includes configurations common to gitlab and gitaly.

Package: golang-gitlab-gitlab-org-gitaly-dev
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
         golang-github-beevik-ntp-dev,
         golang-github-beorn7-perks-dev,
         golang-github-burntsushi-toml-dev,
         golang-github-client9-reopen-dev,
         golang-github-cloudflare-tableflip-dev (>= 1.2~),
         golang-github-containerd-cgroups-dev,
         golang-github-davecgh-go-spew-dev,
         golang-github-dchest-safefile-dev,
         golang-github-getsentry-sentry-go-dev,
         golang-github-git-lfs-git-lfs-dev (>= 3.0~),
         golang-github-google-uuid-dev,
         golang-github-go-enry-go-license-detector-dev,
         golang-github-grpc-ecosystem-go-grpc-middleware-dev (>= 1.2.3~),
         golang-github-grpc-ecosystem-go-grpc-prometheus-dev (>= 1.2~),
         golang-github-hashicorp-golang-lru-dev,
         golang-github-hashicorp-yamux-dev (>= 0.0+git20210316.a95892c~),
         golang-github-jackc-pgconn-dev,
         golang-github-jackc-pgx-v4-dev,
         golang-github-kelseyhightower-envconfig-dev,
         golang-github-lib-pq-dev (>= 1.3~),
         golang-github-opencontainers-specs-dev,
         golang-github-oklog-ulid-dev (>= 2.0~),
         golang-github-pelletier-go-toml.v2-dev,
         golang-github-pmezard-go-difflib-dev,
         golang-github-prometheus-client-golang-dev,
         golang-github-prometheus-client-model-dev,
         golang-github-prometheus-common-dev,
         golang-github-rubenv-sql-migrate-dev,
         golang-github-sebest-xff-dev,
         golang-github-sirupsen-logrus-dev (>= 1.0~),
         golang-github-stretchr-testify-dev (>= 1.4~),
         golang-gitlab-gitlab-org-gitlab-shell-v14-dev,
         golang-gitlab-gitlab-org-labkit-dev,
         golang-gocloud-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-text-dev,
         golang-golang-x-tools,
         golang-google-grpc-dev (>= 1.38.0-3~),
         golang-google-protobuf-dev,
         golang-gopkg-gorp.v1-dev,
         golang-github-libgit2-git2go-v34-dev,
         golang-gopkg-yaml.v2-dev,
         golang-goprotobuf-dev (>= 1.5~),
         golang-honnef-go-tools-dev,
         golang-procfs-dev,
         golang-protobuf-extensions-dev,
         golang-uber-goleak-dev,
Description: Gitaly golang module
 Gitaly makes the git data storage tier of large GitLab instances fast.
 .
 This is achieved by moving git operations as close to the data as possible and
 Optimizing git services using caching.
 .
 Gitaly is a core service of gitlab.
 .
 This package provides golang module of gitaly.
